import _regeneratorRuntime from 'babel-runtime/regenerator';
import _JSON$stringify from 'babel-runtime/core-js/json/stringify';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import fs from 'fs';
import path from 'path';
import CssModules from 'css-modules-loader-core';
import stylus from 'stylus';
import { createFilter } from 'rollup-pluginutils';

function stylusCssModules() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var cssModules = new CssModules();
  var filter = createFilter(options.include || ['**/*.styl', '**/*.stylus'], options.exclude);
  var fn = options.fn;
  var sourceMap = options.sourceMap !== false;
  var outputFile = typeof options.output === 'string';
  var outputFunction = typeof options.output === 'function';
  var noOutput = options.output === false;
  var cache = {};

  return {
    load: function load(id) {
      if (cache[id]) {
        return cache[id].injectableSource;
      }
      return null;
    },
    resolveId: function resolveId(importee, importer) {
      if (cache[importee]) {
        return importee;
      }

      return null;
    },
    transform: function transform(code, id) {
      var _this = this;

      return _asyncToGenerator(_regeneratorRuntime.mark(function _callee() {
        var compiledId, obj, style, relativePath, css, importCode;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (filter(id)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return', null);

              case 2:
                compiledId = id + '.css';
                obj = cache[compiledId];

                if (obj) {
                  _context.next = 17;
                  break;
                }

                // compile Stylus
                style = stylus(code);
                relativePath = path.relative(process.cwd(), id);

                style.set('filename', relativePath);
                if (sourceMap) {
                  style.set('sourcemap', { inline: true });
                }
                if (fn) {
                  style.use(fn);
                }
                _context.next = 12;
                return style.render();

              case 12:
                css = _context.sent;
                _context.next = 15;
                return cssModules.load(css, relativePath, null);

              case 15:
                obj = _context.sent;


                cache[compiledId] = obj;

              case 17:

                // output
                importCode = '';

                if (!outputFile) {
                  _context.next = 23;
                  break;
                }

                _context.next = 21;
                return fs.writeFile(options.output, obj.injectableSource);

              case 21:
                _context.next = 29;
                break;

              case 23:
                if (!outputFunction) {
                  _context.next = 28;
                  break;
                }

                _context.next = 26;
                return options.output(obj.injectableSource);

              case 26:
                _context.next = 29;
                break;

              case 28:
                if (!noOutput) {
                  importCode = 'import ' + _JSON$stringify(compiledId) + ';';
                }

              case 29:
                return _context.abrupt('return', {
                  id: compiledId,
                  code: importCode + 'export default ' + _JSON$stringify(obj.exportTokens) + ';',
                  map: { mappings: '' }
                });

              case 30:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }))();
    }
  };
}

export default stylusCssModules;
